import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'dart:math' ;
import 'dart:async';
import 'package:flutter_easyloading/flutter_easyloading.dart';
import 'inc/thive.dart';
import '../inc/requests.dart';
import 'dart:convert';
import 'package:assets_audio_player/src/assets_audio_player.dart';

final random  = new Random.secure();

int lw=10;
int lh=20;
double opa_keyboard=0.5;
double keyboard_size=40;
List LandMatrix=[];       // матрица стакана с упавшими фигурами
bool GameOver=false;
String Login="Аноним";
final _controllerLogin = TextEditingController();
int MaxScore=0;
final assetsAudioPlayer = AssetsAudioPlayer();

List TableScores=[];
List <int> f__=[]; // []
List <int> f_s=[]; // []
List <int> f_g=[];               // Г
List <int> f_t=[];              // T
List <int> f_z=[]; // Z
List <int> f_dot=[]; // Z
List Figures=[f__,f_s,f_g,f_t,f_z,f_dot];
List <int> MovedFig=[]; // та фигура которая сейчас движется..
List <int> ShadowRotareFig=[]; // "теневой" массив фигуры для повотора (квадрат)
int fcurrent=0;      // номер фигуры которая сейчас движется
Timer? timer;
int score=0;         // набрано очков

class Coords{
  int x=0;
  int y=0;
}

final ButtonStyle raisedButtonStyleSuccess = ElevatedButton.styleFrom(
  onPrimary: Colors.black87,
  primary: Colors.orangeAccent,
  minimumSize: Size(120, 36),
  padding: EdgeInsets.symmetric(horizontal: 16),
  shape: const RoundedRectangleBorder(
    borderRadius: BorderRadius.all(Radius.circular(10)),
  ),
);

Map<int,Color>  FigColors = {
  0: Colors.red,
  1: Colors.green,
  2: Colors.indigoAccent,
  3: Colors.white,
  4: Colors.blue,
  5: Colors.amber,
  99: Colors.black, // цвет стакана
  100: Colors.grey, // заполненый стакан
  101: Colors.white,
};

void CreateFigs(){
  f__=[Coors2Poz(1,1),Coors2Poz(2,1),Coors2Poz(3,1),Coors2Poz(4,1)];
  f_s=[Coors2Poz(1,1),Coors2Poz(2,1),Coors2Poz(1,2),Coors2Poz(2,2)];
  f_g=[Coors2Poz(1,1),Coors2Poz(2,1),Coors2Poz(1,2),Coors2Poz(1,3),Coors2Poz(1,4)];
  f_t=[Coors2Poz(1,1),Coors2Poz(2,1),Coors2Poz(3,1),Coors2Poz(2,2),Coors2Poz(2,3)];
  f_z=[Coors2Poz(2,1),Coors2Poz(3,1),Coors2Poz(2,2),Coors2Poz(2,3),Coors2Poz(1,3)];
  f_dot=[Coors2Poz((lw/2).truncate(),1)];
  Figures=[f__,f_s,f_g,f_t,f_z,f_dot];
}

// получить координаты левого верхнего угла фигуры
Coords GetStartXYFigure(List Fig){
  Coords res=Coords();
  res.x=999;res.y=999;
  for (var i = 0; i < Fig.length; i++) {
    Coords crd=Poz2Coors(Fig[i]);
    if (crd.x<=res.x){res.x=crd.x;};
    if (crd.y<=res.y){res.y=crd.y;};
  };
  return res;
}

// передвинуть фигуру в координаты
List <int> FigureMove(int x,int y,List<int> FM){
  Coords crd_before_move=GetStartXYFigure(MovedFig);
  int step_x=x-crd_before_move.x+2;
  int step_y=y-crd_before_move.y+1;
  for (var i = 0; i < FM.length; i++) {
    Coords tmp_crd=Poz2Coors(FM[i]);
    tmp_crd.x=tmp_crd.x+step_x;
    tmp_crd.y=tmp_crd.y+step_y;
    if (tmp_crd.x>lw){
      print("Ахтунг!");
      FM[0]=-1;
      return FM;
    };
    if (tmp_crd.y>lh){
      print("Ахтунг!");
      FM[0]=-1;
      return FM;
    };
    //print("Сдвиг в ${tmp_crd.x},${tmp_crd.y}");
    FM[i]=Coors2Poz(tmp_crd.x,tmp_crd.y);
  };
  return FM;
}

Coords Poz2Coors(int poz){
  int y=((poz-1)/lw).truncate();
  int x=poz-1-(y*lw);
  Coords res=Coords();
  res.x=x;
  res.y=y;
  //print("poz=$poz => x=$x,y=$y");
  return res;
}
int Coors2Poz(int x,int y){
  return (y-1)*lw+(x+1);
}


void CreateLandMatrix(){
  LandMatrix=[];
  LandMatrix= new List.generate(lh, (_) => new List.filled(lw, 0));
}
void FigureSelections(){
  print("Всего фигур: ${Figures.length}");
  for (var i = 0; i < 10; i++) {
    fcurrent=random.nextInt(Figures.length);
    //print("Выбрана фигура ${fnext}");
  };
  //fcurrent=2;
  MovedFig=List<int>.from(Figures[fcurrent]);
  print("Выбрана фигура ${MovedFig} №${fcurrent}");
  // проверяем переполнение стакана
  for (var i = 0; i < MovedFig.length; i++) {
    Coords crd=Poz2Coors(MovedFig[i]);
    if (LandMatrix[crd.y][crd.x]>0) {
     if (GameOver != true){
          GameOver = true;
        if (score > MaxScore) { //если очков больше чем максмум, сохраням сиё
          MaxScore=score;
          THive have = THive();
          have.Init("auth");
          have.Add("Login", Login);
          have.Add("MaxScore", MaxScore);
          // ну и на сервер закинем данные
          TRequests req = new TRequests();
          req.request("SaveScores", jsonEncode({
            "login": Login,
            "score": MaxScore
          }), (List result) {}, (String error) {
            EasyLoading.showToast(error);
          });
        };
      };
    }
  };
}

void main() async {
  THive have=THive();
  print("--подключаем бокс auth");
  await have.Init("auth");
  if (await have.Get("Login")!="") {
    Login=await have.Get("Login");
    MaxScore=await have.Get("MaxScore");
    print("Найден: $Login, MaxScore=$MaxScore");
  } else {
    print("-сохраненных данных нет, используем по дефолту");
    have.Add("Login", Login);
    have.Add("MaxScore", MaxScore);
  };
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({super.key});
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      builder: EasyLoading.init(),
      title: 'TETRIS',
      theme: ThemeData(
        colorScheme: ColorScheme.fromSeed(seedColor: Colors.deepPurple),
        scaffoldBackgroundColor: Colors.grey.shade800,
        useMaterial3: true,
      ),
      debugShowCheckedModeBanner: false,
      initialRoute: '/home',
      routes: {
        '/game': (BuildContext context) => MyGamePage(title: 'Tetris'),
        '/home': (BuildContext context) => MyHomePage(),
      }
    );
  }
}

class MyGamePage extends StatefulWidget {
  const MyGamePage({super.key, required this.title});
  final String title;
  @override
  State<MyGamePage> createState() => _MyGamePageState();
}
class _MyGamePageState extends State<MyGamePage> {

  void enterFullScreen() {
    SystemChrome.setEnabledSystemUIMode(SystemUiMode.manual, overlays: []);
  }

  void exitFullScreen() {
    SystemChrome.setEnabledSystemUIMode(SystemUiMode.manual, overlays: SystemUiOverlay.values);
  }

  void StartTimer(context){
    timer = Timer.periodic(Duration(seconds: 1), (Timer _) {
      DestroyFullLines();
      print("Сработал таймер..");
      MoveFigDown(context);
    });
  }

  // поворачиваем блок
  void RotateFig(context){
    print("До поворота: ${MovedFig}");
    List <int> OldFig=List<int>.from(MovedFig); //запоминаем фигуру и положение до поворота

    // найдем минимальные координаты x и y до поворота
    Coords crd_before_rotare=GetStartXYFigure(MovedFig);
    print("min_x=${crd_before_rotare.x},min_y=${crd_before_rotare.y}");

    // передвинем фигуру в центр
    int center_x=4;
    int center_y=4;

    MovedFig=FigureMove(center_x,center_y,MovedFig);

    for (var i = 0; i < MovedFig.length; i++) {
      Coords crd=Poz2Coors(MovedFig[i]);
      int new_x=(crd.x * cos(3.1415926535897932/2) - crd.y * sin(3.1415926535897932/2)).round();
      int new_y=(crd.x * sin(3.1415926535897932/2) + crd.y * cos(3.1415926535897932/2)).round();
      MovedFig[i]=Coors2Poz(new_x,new_y);
      //print("x=${new_x},y=${new_y}");
    };
    MovedFig=FigureMove(crd_before_rotare.x-2,crd_before_rotare.y,MovedFig);

    print("После поворота: ${MovedFig}");
    // проверяем, а можно ли было поворачивать?
    if (MovedFig[0]==-1){
      MovedFig=OldFig;
    }
    // проверяем, а нет ли наложения элементов на то что уже в стакане?
    for (var i = 0; i < MovedFig.length; i++) {
      Coords crd=Poz2Coors(MovedFig[i] + lw);
      if (MovedFig[i] + lw<=lw*lh) {
        if (LandMatrix[crd.y][crd.x] > 0) {
          MovedFig=OldFig;
        };
      };
    };
  }

  bool FigOvelay(List <int> FG){
    bool res=false;
    for (var i = 0; i < FG.length; i++) {
      Coords crd=Poz2Coors(FG[i] + lw);
      if (FG[i] + lw<=lw*lh) {
        if (LandMatrix[crd.y][crd.x] > 0) {
          res=true;
          break;
        };
      };
    };
    return res;
  }
  // двигаем фигуру вправо
  void MoveFigLeft(context) {
    if (GameOver==true) {return;};
    bool move=true;
    // проверим, а можем ли двигать влево, не уткнемся ли в стену стакана?
    for (var i = 0; i < MovedFig.length; i++) {
      Coords crd=Poz2Coors(MovedFig[i]);
      print("x=${crd.x}");
      if (crd.x==0){
        move=false;
      };
    };
  // если не упираемся в стенку, то проверяем, что пусто слева
    if (move==true){
      for (var i = 0; i < MovedFig.length; i++) {
        Coords crd=Poz2Coors(MovedFig[i]-1);
        if (LandMatrix[crd.y][crd.x]>0){
          move=false;
        };
      };
    };
    // если таки можем двигаться влево, то передвигаем фигуру
    if (move==true){
      print("Фигура двинулась вправо");
      for (var i = 0; i < MovedFig.length; i++) {
        MovedFig[i] = MovedFig[i] - 1;
      };
    };
  }
  // двигаем фигуру вправо
  void MoveFigRight(context){
    if (GameOver==true) {return;};
    bool move=true;
    // проверим, а можем ли двигать вправо, не уткнемся ли в стену стакана?
    for (var i = 0; i < MovedFig.length; i++) {
      Coords crd=Poz2Coors(MovedFig[i]);
      print("x=${crd.x}");
      if (crd.x>=(lw-1)){
        move=false;
      };
    };
    // если не упираемся в стенку, то проверяем, что пусто справа
    if (move==true){
      for (var i = 0; i < MovedFig.length; i++) {
        Coords crd=Poz2Coors(MovedFig[i]+1);
        if (LandMatrix[crd.y][crd.x]>0){
          move=false;
        };
      };
    };
    // если таки можем двигаться вправо, то передвигаем фигуру
    if (move==true){
      print("Фигура двинулась вправо");
      for (var i = 0; i < MovedFig.length; i++) {
        MovedFig[i] = MovedFig[i] + 1;
      };
    };
  }
  // двигаем фигуру вниз
  void MoveFigDown(context){
      if (GameOver==true) {return;};
      bool move=true;
      // проверим,при следующем шаге, ни одна ли из точек не достигнет дна колодца при движении вниз?
      for (var i = 0; i < MovedFig.length; i++) {
        // проверка дна колодца
        if ((MovedFig[i] + lw)>lw*lh){
          move=false;
        };
        // проверка что наезд на другую фигуру
        Coords crd=Poz2Coors(MovedFig[i] + lw);
        if (MovedFig[i] + lw<=lw*lh) {
          if (LandMatrix[crd.y][crd.x] > 0) {
            move = false;
          };
        };
      };
      if (move==true) {
        for (var i = 0; i < MovedFig.length; i++) {
          MovedFig[i] = MovedFig[i] + lw;
        };
      };
      // если не можем двигаться вниз, то переносим фигуру в "стакан"
      if (move==false){
        print("-переносим фигуру в стакан");
        for (var i = 0; i < MovedFig.length; i++) {
          Coords crd=Poz2Coors(MovedFig[i]);
          LandMatrix[crd.y][crd.x]=1;
        };
        DestroyFullLines();
        // создаём новую фигуру
        FigureSelections();
      };
      setState(() {
        MovedFig=MovedFig;
      });
    print("Фигура двинулась вниз: ${MovedFig}");
      String audioasset = "lib/sounds/click.mp3";
      AssetsAudioPlayer.newPlayer().open(
          Audio(audioasset)
      );
  }

  // смотрим, а нет ли закрытых линий в стакане?
  void DestroyFullLines(){
    print("проверка необходимости удаления заполненых линий");
    for (var h = 0; h < lh; h++) {
      bool destroy=true;
      for (var w = 0; w < lw; w++) {
        if (LandMatrix[h][w]==0){
          destroy=false;
        };
      };
      if (destroy==true){
        print("кажется комуто нужно срочно похудеть...");
        score++;
        for (var w = 0; w < lw; w++) {LandMatrix[h][w]=101;}; // чищу заполненую строчку
        // передвигаю все строчки что выше - ниже
        print("Цикл с $h по 1");
        int poz=h-1;
        for (var hz = 1; hz <= h; hz++) {
          print("копирую строчку $poz в ${poz+1}");
          for (var w = 0; w < lw; w++) {
            LandMatrix[poz+1][w]=LandMatrix[poz][w];
            LandMatrix[poz][w]=0;
          }
          poz--;
        };
        //for (var w = 0; w < lw; w++) {LandMatrix[0][w]=101;}; // чищу первую строчку
        String audioasset = "lib/sounds/babah.mp3";
        AssetsAudioPlayer.newPlayer().open(
            Audio(audioasset)
        );

      };
    };
    THive have=THive();
    have.Init("auth");
    have.Add("Login", Login);
    have.Add("MaxScore", MaxScore);
  }

  @override
  void initState() {
    super.initState();
    SystemChrome.setSystemUIChangeCallback((systemOverlaysAreVisible) async {
      print('System overlays are visible: $systemOverlaysAreVisible');
    });
    enterFullScreen();  // входим в полноэкранный режим
    CreateFigs();       // конвертируем координаты фигур в позиции
    CreateLandMatrix(); // очистим сткан упавших фигур
    FigureSelections(); // добавляем случайную фигуру в матрицу падающих фигур
 //   WidgetsBinding.instance.addPostFrameCallback((_) => StartTimer(context)); // фигуры начинают падать
    timer?.cancel();
    StartTimer(context);

  }

  List <Widget> MyLandView(){
    int poz=0;
    return List<Widget>.generate(lh, (int index_h){
      return Row(
        children:
        List<Widget>.generate(lw, (int index_w){
          poz++;
          Color BoxColor=FigColors[99]??Colors.black;
          if (MovedFig.contains(poz)==true){
            BoxColor=FigColors[fcurrent]??Colors.black;
          };
          Coords crd=Poz2Coors(poz);
          // если в стакане что-то есть - рисуем
          if (LandMatrix[crd.y][crd.x]>0){  // если  клетка не пустая
            BoxColor=FigColors[100]??Colors.black;
          };
          if (LandMatrix[crd.y][crd.x]==101){  //
            BoxColor=FigColors[101]??Colors.black;
          };
          if (BoxColor==FigColors[100]){
            //определяем это верхний блок или под ним еще что есть?
            bool ground_top=false;
              Coords crd_tmp=Poz2Coors(poz-lw);
              print("Строчка: ${crd.y},${crd.x}");
              print("Строчка вниз: ${crd_tmp.y},${crd_tmp.x}");
              if (crd_tmp.y>0) {
                if (LandMatrix[crd_tmp.y][crd_tmp.x] >0) {
                  print("-- ниже  есть земля!");
                  ground_top = true;
                }
              }
            return
                Container(
                  color: BoxColor,
                  height: MediaQuery.of(context).size.height/lh,
                  width: MediaQuery.of(context).size.width/lw,
                  child:
                    Image.asset(
                        !ground_top?"lib/images/ground.png":"lib/images/ground_full.png",
                      height: 10,
                      width: 10,
                      fit: BoxFit.fill,
                    ),
                );
          } else {
            return
              Padding(
                  padding: EdgeInsets.all(1),
                  child:
                  Container(
                    color: BoxColor,
                    height: MediaQuery.of(context).size.height / lh - 2,
                    width: MediaQuery.of(context).size.width / lw - 2,
                    //child: Text("$poz")
                  )
              );
          };
        }),
      );
    });
  }

  @override
  Widget build(BuildContext context) {

    return Scaffold(
      body:
        Stack(
          children: [
            Column(
              children: MyLandView()
            ),
            Visibility(
                visible: GameOver,
                child:
                  Padding(
                    padding: EdgeInsets.only(top: 100,left: 20,right: 20),
                    child:
                      Column(
                        children: [
                          Container(
                              padding: const EdgeInsets.all(16.0),
                              width: double.infinity,
                              decoration: BoxDecoration(
                                  color: Colors.black,
                                  borderRadius: BorderRadius.only(
                                    topLeft: Radius.circular(32.0),
                                    topRight: Radius.circular(32.0),
                                    bottomRight: Radius.circular(32.0),
                                    bottomLeft: Radius.circular(32.0),
                                  )
                              ),
                              child:
                              Text("Вот и всё ребята..", style: TextStyle(fontSize: 14.0, color: Colors.red))
                          ),
                          ElevatedButton(
                            style: raisedButtonStyleSuccess,
                            onPressed: (){
                              setState(() {
                                score=0;
                                GameOver=false;
                                CreateLandMatrix(); // очистим сткан упавших фигур
                                FigureSelections(); // добавляем случайную фигуру в матрицу падающих фигур
                                //   WidgetsBinding.instance.addPostFrameCallback((_) => StartTimer(context)); // фигуры начинают падать
                              });
                            },
                            child: Text('Начать заново', style: TextStyle(color: Colors.white,fontSize: 12)),
                          ),
                          ElevatedButton(
                            style: raisedButtonStyleSuccess,
                            onPressed: (){
                              setState(() {
                                Navigator.pushNamed(context,'/home');
                              });
                            },
                            child: Text('В меню', style: TextStyle(color: Colors.white,fontSize: 12)),
                          )
                        ],
                      ),
                  )
            ),  // надпись "конец игры"
            Container(
              width: MediaQuery.of(context).size.width,
              child:
                  Padding(
                    padding: EdgeInsets.only(bottom: 10),
                    child:
                      Column(
                      children: [
                        Expanded(
                            child:
                                Container(),
                        ),
                        /*
                        Row(
                            mainAxisSize: MainAxisSize.max,
                            mainAxisAlignment: MainAxisAlignment.end,
                            children: [
                              Container(
                                width: keyboard_size,height: keyboard_size,
                              ),
                              GestureDetector(
                                onTap: () {
                                  if (timer==null) {
                                    StartTimer(context);
                                  };
                                },
                                child:    Container(
                                //  color: Colors.black,
                                  child:
                                  Image.asset(
                                    "lib/images/start.png",
                                    height: 40,
                                    width: 68,
                                  ),
                                ),
                              ),
                              Container(
                                width: keyboard_size,height: keyboard_size,
                              ),
                            ]
                        ),
                         */
                        Row(
                          mainAxisSize: MainAxisSize.max,
                          mainAxisAlignment: MainAxisAlignment.end,
                          children: [
                            IconButton (
                              padding: const EdgeInsets.all(0),
                              color: Colors.white.withOpacity(opa_keyboard),
                              icon:  ImageIcon(
                                AssetImage("lib/images/rigth.png"),
                                color: Colors.grey,
                              ),
                              onPressed: () {
                                 setState(() {
                                   MoveFigLeft(context);
                                 });
                                },
                            ),
                            IconButton (
                              padding: const EdgeInsets.all(0),
                              color: Colors.white.withOpacity(opa_keyboard),
                              icon:  Icon(Icons.replay, size: keyboard_size),
                              onPressed: () {
                                setState(() {
                                  RotateFig(context);
                                });
                              },
                            ),

                            IconButton (
                              padding: const EdgeInsets.all(0),
                              color: Colors.white.withOpacity(opa_keyboard),
                              icon:  ImageIcon(
                                AssetImage("lib/images/left.png"),
                                color: Colors.grey,
                              ),
                              onPressed: () {
                               setState(() {
                                 MoveFigRight(context);
                               });
                              },
                            ),
                          ],
                        ),
                        Row(
                            mainAxisSize: MainAxisSize.max,
                            mainAxisAlignment: MainAxisAlignment.end,
                            children: [
                              Container(
                                width: keyboard_size,height: keyboard_size,
                              ),
                              IconButton (
                                color: Colors.white.withOpacity(opa_keyboard),
                                padding: const EdgeInsets.all(0),
                                icon:  ImageIcon(
                                  AssetImage("lib/images/down.png"),
                                  color: Colors.grey,
                                ),
                                onPressed: () {
                                  setState(() {
                                    if (timer==null){
                                      EasyLoading.showToast("Игра еще не стартовала..");
                                    } else {
                                      MoveFigDown(context);
                                    }
                                  });
                                },
                              ),
                              Container(
                                width: keyboard_size,height: keyboard_size,
                              ),
                            ]
                        ),
                      ],
                    )  // кнопки для нажатия
                  )
            ) ,
            Container(
              child:
                Align(
                  alignment: Alignment.bottomRight,
                  child:
                    Padding(
                      padding: EdgeInsets.all(5),
                      child: Text(
                          'Очки:'+score.toString(),
                          style: TextStyle(
                              shadows: <Shadow>[
                                Shadow(
                                  offset: Offset(10.0, 10.0),
                                  blurRadius: 3.0,
                                  color: Color.fromARGB(255, 0, 0, 0),
                                ),
                                Shadow(
                                  offset: Offset(10.0, 10.0),
                                  blurRadius: 8.0,
                                  color: Color.fromARGB(125, 0, 0, 255),
                                ),
                              ],
                              color: Colors.white,fontSize: 12
                          )
                      ),
                    )
                )
            )// кнопки управления
          ],

        )
    );
  }
}

class MyHomePage extends StatefulWidget {
  _MyHomePageState createState() => _MyHomePageState(); // сюда передаем текущее состояние страницы
}
class _MyHomePageState extends State<MyHomePage> {
  void LoadScores(context){
    TRequests req=new TRequests();
    req.request("LoadScores", jsonEncode({}), (List result){
      setState(() {
        TableScores=result;
        print(TableScores);
      });
    }, (String error){
      EasyLoading.showToast(error);
    });


    assetsAudioPlayer.open(
      Audio("lib/sounds/tetris.mp3"),
    );



  }
  @override
  void initState() {
    _controllerLogin.text=Login;
    _controllerLogin.addListener(() {
      print(_controllerLogin.text);
      Login=_controllerLogin.text;
      THive have = THive();
      have.Init("auth");
      have.Add("Login", Login);
      have.Add("MaxScore", MaxScore);
    });
    super.initState();
    WidgetsBinding.instance.addPostFrameCallback((_) => LoadScores(context));  // эвент после того как страница отобразилась - обновим данные по пользователю
  }
  @override
  Widget build(BuildContext context) {
    return Scaffold(
        body:
         Column(
           children: [
             Text("Пользователь",style: TextStyle(fontSize: 22,color: Colors.green),),
             TextField(
               style: TextStyle(fontSize: 22,color: Colors.red),
               textAlign: TextAlign.center,
               controller: _controllerLogin,
               obscureText: false,
               enableSuggestions: false,
               autocorrect: false,
             ),
             Text("Рекорд: $MaxScore очков",style: TextStyle(fontSize: 22,color: Colors.green),),
             GestureDetector(
               onTap: (){
                 FocusScope.of(context).requestFocus(new FocusNode());
               },
               child:
                  Image.asset("lib/images/rus.png"),
             ),
             ElevatedButton(
               style: raisedButtonStyleSuccess,
               onPressed: (){
                 setState(() {
                   Navigator.pushNamed(context,'/game');
                 });
               },
               child: Text('Начать игру', style: TextStyle(color: Colors.white,fontSize: 12)),
             ),
             Text("Рекорды",style: TextStyle(fontSize: 22,color: Colors.amber)),
             Expanded(
                 child:
                 ListView.builder(
                   padding: const EdgeInsets.all(8),
                   itemCount: TableScores.length,
                    itemBuilder: (BuildContext context, int index) {
                     return Row(
                       mainAxisAlignment: MainAxisAlignment.spaceBetween,
                       children: [
                         Text((index+1).toString(),style: TextStyle(fontSize: 14,color: Colors.indigoAccent)),
                         Text(TableScores[index]["login"],style: TextStyle(fontSize: 14,color: Colors.green)),
                         Text(TableScores[index]["score"].toString(),style: TextStyle(fontSize: 14,color: Colors.green)),
                       ],
                     );
                    }
                 )
             )

           ],
         )
    );
  }
}